
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity puf is
port(
  		main_UART_in : in std_logic;
		main_UART_out: out std_logic;
		dummyout: out std_logic_vector(127 downto 0 );
      clk          : in  std_logic
);
end entity puf;

architecture rtl of puf is
--components
component UART_TX
 port (
    i_Clk       : in  std_logic;
    i_TX_DV     : in  std_logic;
    i_TX_Byte   : in  std_logic_vector(7 downto 0);
    o_TX_Active : out std_logic;
    o_TX_Serial : out std_logic;
    o_TX_Done   : out std_logic
	 
    );
end component;

component UART_RX
 port (
    i_Clk       : in  std_logic;
    i_RX_Serial : in  std_logic;
    o_RX_DV     : out std_logic;
    o_RX_Byte   : out std_logic_vector(7 downto 0)
	 
    );
end component;  
component mux128
 port (
  a0      : in  std_logic;
  a1      : in  std_logic;
  a2      : in  std_logic;
  a3      : in  std_logic;
  a4      : in  std_logic;
  a5      : in  std_logic;
  a6      : in  std_logic;
  a7      : in  std_logic;
  a8      : in  std_logic;
  a9      : in  std_logic;
  a10      : in  std_logic;
  a11      : in  std_logic;
  a12      : in  std_logic;
  a13      : in  std_logic;
  a14      : in  std_logic;
  a15      : in  std_logic;
  a16      : in  std_logic;
  a17      : in  std_logic;
  a18      : in  std_logic;
  a19      : in  std_logic;
  a20      : in  std_logic;  
  a21      : in  std_logic;  
  a22      : in  std_logic;
  a23      : in  std_logic;
  a24      : in  std_logic;
  a25      : in  std_logic;
  a26      : in  std_logic;
  a27      : in  std_logic;
  a28      : in  std_logic;
  a29      : in  std_logic;
  a30      : in  std_logic;
  a31      : in  std_logic;
  a32      : in  std_logic;
  a33      : in  std_logic;
  a34      : in  std_logic;
  a35      : in  std_logic;
  a36      : in  std_logic;
  a37      : in  std_logic;
  a38      : in  std_logic;
  a39      : in  std_logic;
  a40      : in  std_logic;
  a41      : in  std_logic;
  a42      : in  std_logic;
  a43      : in  std_logic;
  a44      : in  std_logic;
  a45      : in  std_logic;
  a46      : in  std_logic;
  a47      : in  std_logic;
  a48      : in  std_logic;
  a49      : in  std_logic;
  a50      : in  std_logic;
  a51      : in  std_logic;
  a52      : in  std_logic;
  a53      : in  std_logic;
  a54      : in  std_logic;
  a55      : in  std_logic;
  a56      : in  std_logic;
  a57      : in  std_logic;
  a58      : in  std_logic;
  a59      : in  std_logic;  
  a60      : in  std_logic;
  a61      : in  std_logic;
  a62      : in  std_logic;
  a63      : in  std_logic;
  a64      : in  std_logic;
  a65      : in  std_logic;
  a66      : in  std_logic;
  a67      : in  std_logic;
  a68      : in  std_logic;
  a69      : in  std_logic;  
  a70      : in  std_logic;
  a71      : in  std_logic;
  a72      : in  std_logic;
  a73      : in  std_logic;
  a74      : in  std_logic;
  a75      : in  std_logic;
  a76      : in  std_logic;
  a77      : in  std_logic;
  a78      : in  std_logic;
  a79      : in  std_logic;  
  a80      : in  std_logic;
  a81      : in  std_logic;
  a82      : in  std_logic;
  a83      : in  std_logic;
  a84      : in  std_logic;
  a85      : in  std_logic;
  a86      : in  std_logic;
  a87      : in  std_logic;
  a88      : in  std_logic;
  a89      : in  std_logic;  
  a90      : in  std_logic;
  a91      : in  std_logic;
  a92      : in  std_logic;
  a93      : in  std_logic;
  a94      : in  std_logic;
  a95      : in  std_logic;
  a96      : in  std_logic;
  a97      : in  std_logic;
  a98      : in  std_logic;
  a99      : in  std_logic;
  a100      : in  std_logic;
  a101      : in  std_logic;
  a102      : in  std_logic;
  a103      : in  std_logic;
  a104      : in  std_logic;
  a105      : in  std_logic;
  a106      : in  std_logic;
  a107      : in  std_logic;
  a108      : in  std_logic;
  a109      : in  std_logic;
  a110      : in  std_logic;
  a111      : in  std_logic;
  a112      : in  std_logic;
  a113      : in  std_logic;
  a114      : in  std_logic;
  a115      : in  std_logic;
  a116      : in  std_logic;
  a117      : in  std_logic;
  a118      : in  std_logic;
  a119      : in  std_logic;
  a120      : in  std_logic;  
  a121      : in  std_logic;  
  a122      : in  std_logic;
  a123      : in  std_logic;
  a124      : in  std_logic;
  a125      : in  std_logic;
  a126      : in  std_logic;
  a127      : in  std_logic;
  a128      : in  std_logic;
  a129      : in  std_logic;
  a130      : in  std_logic;
  a131      : in  std_logic;
  a132      : in  std_logic;
  a133      : in  std_logic;
  a134      : in  std_logic;
  a135      : in  std_logic;
  a136      : in  std_logic;
  a137      : in  std_logic;
  a138      : in  std_logic;
  a139      : in  std_logic;
  a140      : in  std_logic;
  a141      : in  std_logic;
  a142      : in  std_logic;
  a143      : in  std_logic;
  a144      : in  std_logic;
  a145      : in  std_logic;
  a146      : in  std_logic;
  a147      : in  std_logic;
  a148      : in  std_logic;
  a149      : in  std_logic;
  a150      : in  std_logic;
  a151      : in  std_logic;
  a152      : in  std_logic;
  a153      : in  std_logic;
  a154      : in  std_logic;
  a155      : in  std_logic;
  a156      : in  std_logic;
  a157      : in  std_logic;
  a158      : in  std_logic;
  a159      : in  std_logic;  
  a160      : in  std_logic;
  a161      : in  std_logic;
  a162      : in  std_logic;
  a163      : in  std_logic;
  a164      : in  std_logic;
  a165      : in  std_logic;
  a166      : in  std_logic;
  a167      : in  std_logic;
  a168      : in  std_logic;
  a169      : in  std_logic;  
  a170      : in  std_logic;
  a171      : in  std_logic;
  a172      : in  std_logic;
  a173      : in  std_logic;
  a174      : in  std_logic;
  a175      : in  std_logic;
  a176      : in  std_logic;
  a177      : in  std_logic;
  a178      : in  std_logic;
  a179      : in  std_logic;  
  a180      : in  std_logic;
  a181      : in  std_logic;
  a182      : in  std_logic;
  a183      : in  std_logic;
  a184      : in  std_logic;
  a185      : in  std_logic;
  a186      : in  std_logic;
  a187      : in  std_logic;
  a188      : in  std_logic;
  a189      : in  std_logic;  
  a190      : in  std_logic;
  a191      : in  std_logic;
  a192      : in  std_logic;
  a193      : in  std_logic;
  a194      : in  std_logic;
  a195      : in  std_logic;
  a196      : in  std_logic;
  a197      : in  std_logic;
  a198      : in  std_logic;
  a199      : in  std_logic;
  a200      : in  std_logic;
  a201      : in  std_logic;
  a202      : in  std_logic;
  a203      : in  std_logic;
  a204      : in  std_logic;
  a205      : in  std_logic;
  a206      : in  std_logic;
  a207      : in  std_logic;
  a208      : in  std_logic;
  a209      : in  std_logic;
  a210      : in  std_logic;
  a211      : in  std_logic;
  a212      : in  std_logic;
  a213      : in  std_logic;
  a214      : in  std_logic;
  a215      : in  std_logic;
  a216      : in  std_logic;
  a217      : in  std_logic;
  a218      : in  std_logic;
  a219      : in  std_logic;
  a220      : in  std_logic;  
  a221      : in  std_logic;  
  a222      : in  std_logic;
  a223      : in  std_logic;
  a224      : in  std_logic;
  a225      : in  std_logic;
  a226      : in  std_logic;
  a227      : in  std_logic;
  a228      : in  std_logic;
  a229      : in  std_logic;
  a230      : in  std_logic;
  a231      : in  std_logic;
  a232      : in  std_logic;
  a233      : in  std_logic;
  a234      : in  std_logic;
  a235      : in  std_logic;
  a236      : in  std_logic;
  a237      : in  std_logic;
  a238      : in  std_logic;
  a239      : in  std_logic;
  a240      : in  std_logic;
  a241      : in  std_logic;
  a242      : in  std_logic;
  a243      : in  std_logic;
  a244      : in  std_logic;
  a245      : in  std_logic;
  a246      : in  std_logic;
  a247      : in  std_logic;
  a248      : in  std_logic;
  a249      : in  std_logic;
  a250      : in  std_logic;
  a251      : in  std_logic;
  a252      : in  std_logic;
  a253      : in  std_logic;
  a254      : in  std_logic;
  a255      : in  std_logic;   
  sel     : in  std_logic_vector(7 downto 0);
  b       : out std_logic
	 
    );
end component; 

  component ring_oscillator is
    port (
      en1   : in  std_logic;
		mode1: in std_logic;
      out1 : out std_logic);
  end component ring_oscillator;
  
  component counter is

    port (
      clk      : in  std_logic;
      rstn     : in  std_logic;
      ena      : in  std_logic;
      count    : out std_logic_vector(63 downto 0));
  end component counter;
--end component




--UART begin
signal solution1: std_logic;  
signal main_clk1: std_logic;
signal  TX_i_TX_DV     : std_logic:='0';
signal  TX_i_TX_Byte   : std_logic_vector(7 downto 0);
signal  TX_o_TX_Active : std_logic;
signal  TX_o_TX_Done   : std_logic;
--connect to UART_RX
signal  RX_o_RX_DV     : std_logic;
signal  RX_o_RX_Byte   : std_logic_vector(7 downto 0);
--state machine

signal main_plaintext: std_logic_vector(63 downto 0);
signal main_ciphertext: std_logic_vector(63 downto 0);
signal count_rx: integer range 0 to 8:=0;
signal count_tx: integer range 0 to 8:=0;
  
--resposne generation
signal bitvalue: integer range 0 to 63:=0;
signal b: integer;
signal response0:integer;
signal response1:integer;
signal rstn_counter: std_logic;
signal rstn_osc: std_logic_vector(255 downto 0);
signal ena_counter: std_logic;
--osc
signal osc0: std_logic:='0';
signal osc1: std_logic:='0';
signal osc2: std_logic:='0';
signal osc3: std_logic:='0';
signal osc4: std_logic:='0';
signal osc5: std_logic:='0';
signal osc6: std_logic:='0';
signal osc7: std_logic:='0';
signal osc8: std_logic:='0';
signal osc9: std_logic:='0';
signal osc10: std_logic:='0';
signal osc11: std_logic:='0';
signal osc12: std_logic:='0';
signal osc13: std_logic:='0';
signal osc14: std_logic:='0';
signal osc15: std_logic:='0';
signal osc16: std_logic:='0';
signal osc17: std_logic:='0';
signal osc18: std_logic:='0';
signal osc19: std_logic:='0';
signal osc20: std_logic:='0';
signal osc21: std_logic:='0';
signal osc22: std_logic:='0';
signal osc23: std_logic:='0';
signal osc24: std_logic:='0';
signal osc25: std_logic:='0';
signal osc26: std_logic:='0';
signal osc27: std_logic:='0';
signal osc28: std_logic:='0';
signal osc29: std_logic:='0';
signal osc30: std_logic:='0';
signal osc31: std_logic:='0';
signal osc32: std_logic:='0';
signal osc33: std_logic:='0';
signal osc34: std_logic:='0';
signal osc35: std_logic:='0';
signal osc36: std_logic:='0';
signal osc37: std_logic:='0';
signal osc38: std_logic:='0';
signal osc39: std_logic:='0';
signal osc40: std_logic:='0';
signal osc41: std_logic:='0';
signal osc42: std_logic:='0';
signal osc43: std_logic:='0';
signal osc44: std_logic:='0';
signal osc45: std_logic:='0';
signal osc46: std_logic:='0';
signal osc47: std_logic:='0';
signal osc48: std_logic:='0';
signal osc49: std_logic:='0';
signal osc50: std_logic:='0';
signal osc51: std_logic:='0';
signal osc52: std_logic:='0';
signal osc53: std_logic:='0';
signal osc54: std_logic:='0';
signal osc55: std_logic:='0';
signal osc56: std_logic:='0';
signal osc57: std_logic:='0';
signal osc58: std_logic:='0';
signal osc59: std_logic:='0';
signal osc60: std_logic:='0';
signal osc61: std_logic:='0';
signal osc62: std_logic:='0';
signal osc63: std_logic:='0';
signal osc64: std_logic:='0';
signal osc65: std_logic:='0';
signal osc66: std_logic:='0';
signal osc67: std_logic:='0';
signal osc68: std_logic:='0';
signal osc69: std_logic:='0';
signal osc70: std_logic:='0';
signal osc71: std_logic:='0';
signal osc72: std_logic:='0';
signal osc73: std_logic:='0';
signal osc74: std_logic:='0';
signal osc75: std_logic:='0';
signal osc76: std_logic:='0';
signal osc77: std_logic:='0';
signal osc78: std_logic:='0';
signal osc79: std_logic:='0';
signal osc80: std_logic:='0';
signal osc81: std_logic:='0';
signal osc82: std_logic:='0';
signal osc83: std_logic:='0';
signal osc84: std_logic:='0';
signal osc85: std_logic:='0';
signal osc86: std_logic:='0';
signal osc87: std_logic:='0';
signal osc88: std_logic:='0';
signal osc89: std_logic:='0';
signal osc90: std_logic:='0';
signal osc91: std_logic:='0';
signal osc92: std_logic:='0';
signal osc93: std_logic:='0';
signal osc94: std_logic:='0';
signal osc95: std_logic:='0';
signal osc96: std_logic:='0';
signal osc97: std_logic:='0';
signal osc98: std_logic:='0';
signal osc99: std_logic:='0';
signal osc100: std_logic:='0';
signal osc101: std_logic:='0';
signal osc102: std_logic:='0';
signal osc103: std_logic:='0';
signal osc104: std_logic:='0';
signal osc105: std_logic:='0';
signal osc106: std_logic:='0';
signal osc107: std_logic:='0';
signal osc108: std_logic:='0';
signal osc109: std_logic:='0';
signal osc110: std_logic:='0';
signal osc111: std_logic:='0';
signal osc112: std_logic:='0';
signal osc113: std_logic:='0';
signal osc114: std_logic:='0';
signal osc115: std_logic:='0';
signal osc116: std_logic:='0';
signal osc117: std_logic:='0';
signal osc118: std_logic:='0';
signal osc119: std_logic:='0';
signal osc120: std_logic:='0';
signal osc121: std_logic:='0';
signal osc122: std_logic:='0';
signal osc123: std_logic:='0';
signal osc124: std_logic:='0';
signal osc125: std_logic:='0';
signal osc126: std_logic:='0';
signal osc127: std_logic:='0';
signal osc128: std_logic:='0';
signal osc129: std_logic:='0';
signal osc130: std_logic:='0';
signal osc131: std_logic:='0';
signal osc132: std_logic:='0';
signal osc133: std_logic:='0';
signal osc134: std_logic:='0';
signal osc135: std_logic:='0';
signal osc136: std_logic:='0';
signal osc137: std_logic:='0';
signal osc138: std_logic:='0';
signal osc139: std_logic:='0';
signal osc140: std_logic:='0';
signal osc141: std_logic:='0';
signal osc142: std_logic:='0';
signal osc143: std_logic:='0';
signal osc144: std_logic:='0';
signal osc145: std_logic:='0';
signal osc146: std_logic:='0';
signal osc147: std_logic:='0';
signal osc148: std_logic:='0';
signal osc149: std_logic:='0';
signal osc150: std_logic:='0';
signal osc151: std_logic:='0';
signal osc152: std_logic:='0';
signal osc153: std_logic:='0';
signal osc154: std_logic:='0';
signal osc155: std_logic:='0';
signal osc156: std_logic:='0';
signal osc157: std_logic:='0';
signal osc158: std_logic:='0';
signal osc159: std_logic:='0';
signal osc160: std_logic:='0';
signal osc161: std_logic:='0';
signal osc162: std_logic:='0';
signal osc163: std_logic:='0';
signal osc164: std_logic:='0';
signal osc165: std_logic:='0';
signal osc166: std_logic:='0';
signal osc167: std_logic:='0';
signal osc168: std_logic:='0';
signal osc169: std_logic:='0';
signal osc170: std_logic:='0';
signal osc171: std_logic:='0';
signal osc172: std_logic:='0';
signal osc173: std_logic:='0';
signal osc174: std_logic:='0';
signal osc175: std_logic:='0';
signal osc176: std_logic:='0';
signal osc177: std_logic:='0';
signal osc178: std_logic:='0';
signal osc179: std_logic:='0';
signal osc180: std_logic:='0';
signal osc181: std_logic:='0';
signal osc182: std_logic:='0';
signal osc183: std_logic:='0';
signal osc184: std_logic:='0';
signal osc185: std_logic:='0';
signal osc186: std_logic:='0';
signal osc187: std_logic:='0';
signal osc188: std_logic:='0';
signal osc189: std_logic:='0';
signal osc190: std_logic:='0';
signal osc191: std_logic:='0';
signal osc192: std_logic:='0';
signal osc193: std_logic:='0';
signal osc194: std_logic:='0';
signal osc195: std_logic:='0';
signal osc196: std_logic:='0';
signal osc197: std_logic:='0';
signal osc198: std_logic:='0';
signal osc199: std_logic:='0';
signal osc200: std_logic:='0';
signal osc201: std_logic:='0';
signal osc202: std_logic:='0';
signal osc203: std_logic:='0';
signal osc204: std_logic:='0';
signal osc205: std_logic:='0';
signal osc206: std_logic:='0';
signal osc207: std_logic:='0';
signal osc208: std_logic:='0';
signal osc209: std_logic:='0';
signal osc210: std_logic:='0';
signal osc211: std_logic:='0';
signal osc212: std_logic:='0';
signal osc213: std_logic:='0';
signal osc214: std_logic:='0';
signal osc215: std_logic:='0';
signal osc216: std_logic:='0';
signal osc217: std_logic:='0';
signal osc218: std_logic:='0';
signal osc219: std_logic:='0';
signal osc220: std_logic:='0';
signal osc221: std_logic:='0';
signal osc222: std_logic:='0';
signal osc223: std_logic:='0';
signal osc224: std_logic:='0';
signal osc225: std_logic:='0';
signal osc226: std_logic:='0';
signal osc227: std_logic:='0';
signal osc228: std_logic:='0';
signal osc229: std_logic:='0';
signal osc230: std_logic:='0';
signal osc231: std_logic:='0';
signal osc232: std_logic:='0';
signal osc233: std_logic:='0';
signal osc234: std_logic:='0';
signal osc235: std_logic:='0';
signal osc236: std_logic:='0';
signal osc237: std_logic:='0';
signal osc238: std_logic:='0';
signal osc239: std_logic:='0';
signal osc240: std_logic:='0';
signal osc241: std_logic:='0';
signal osc242: std_logic:='0';
signal osc243: std_logic:='0';
signal osc244: std_logic:='0';
signal osc245: std_logic:='0';
signal osc246: std_logic:='0';
signal osc247: std_logic:='0';
signal osc248: std_logic:='0';
signal osc249: std_logic:='0';
signal osc250: std_logic:='0';
signal osc251: std_logic:='0';
signal osc252: std_logic:='0';
signal osc253: std_logic:='0';
signal osc254: std_logic:='0';
signal osc255: std_logic:='0';



--count
signal response1_tmp: integer;
signal response0_tmp: integer;
signal sel: std_logic_vector(7 downto 0):="00000000";
signal sel1: std_logic_vector(7 downto 0):="00000000";
signal sel0: std_logic_vector(7 downto 0):="00000000";
signal mux_out:std_logic;
signal counter_out:std_logic_vector(63 downto 0);
signal Control1: integer range 0 to 127;
signal Control0: integer range 0 to 127;
signal wait8,wait7,wait6,wait5,wait2,wait4,wait3,wait1:integer;
signal solution:std_logic;
signal mode: std_logic;
--FSM
type FSM is (Receive_challenge,PUF_pair,PUF_pair1,PUF_pair2, PUF_pair_before, PUF_response1_start,PUF_response1_counting,PUF_response1_calculation, PUF_response_mid,PUF_response_mid1, PUF_response_judge1,
PUF_response0_start,PUF_response0_counting,PUF_response0_calculation,PUF_response_calculation,PUF_response_judge,PUF_send_wait,PUF_send_wait1,
PUF_response0_send,PUF_response1_send,PUF_send0_wait,PUF_send0_wait1);
signal PUF_FSM: FSM := Receive_challenge;
begin

--UART connection
U_TX: UART_TX port map (i_Clk => main_clk1, i_TX_DV=>TX_i_TX_DV, i_TX_Byte=>TX_i_TX_Byte,o_TX_Active=>TX_o_TX_Active,o_TX_Serial=>main_UART_out,o_TX_Done=>TX_o_TX_Done);
U_RX: UART_RX port map (i_Clk=>main_clk1, o_RX_DV=>RX_o_RX_DV,o_RX_Byte=>RX_o_RX_Byte, i_RX_Serial=>main_UART_in);
--RO generation
U0_OSC1: ring_oscillator port map (en1 => rstn_osc(0), out1 => osc0, mode1=>mode);
U0_OSC2: ring_oscillator port map (en1 => rstn_osc(1), out1 => osc1, mode1=>mode);
U0_OSC3: ring_oscillator port map (en1 => rstn_osc(2), out1 => osc2, mode1=>mode);
U0_OSC4: ring_oscillator port map (en1 => rstn_osc(3), out1 => osc3, mode1=>mode);
U0_OSC5: ring_oscillator port map (en1 => rstn_osc(4), out1 => osc4, mode1=>mode);
U0_OSC6: ring_oscillator port map (en1 => rstn_osc(5), out1 => osc5, mode1=>mode);
U0_OSC7: ring_oscillator port map (en1 => rstn_osc(6), out1 => osc6, mode1=>mode);
U0_OSC8: ring_oscillator port map (en1 => rstn_osc(7), out1 => osc7, mode1=>mode);
U0_OSC9: ring_oscillator port map (en1 => rstn_osc(8), out1 => osc8, mode1=>mode);
U0_OSC10: ring_oscillator port map (en1 => rstn_osc(9), out1 => osc9, mode1=>mode);
U0_OSC11: ring_oscillator port map (en1 => rstn_osc(10), out1 => osc10, mode1=>mode);
U0_OSC12: ring_oscillator port map (en1 => rstn_osc(11), out1 => osc11, mode1=>mode);
U0_OSC13: ring_oscillator port map (en1 => rstn_osc(12), out1 => osc12, mode1=>mode);
U0_OSC14: ring_oscillator port map (en1 => rstn_osc(13), out1 => osc13, mode1=>mode);
U0_OSC15: ring_oscillator port map (en1 => rstn_osc(14), out1 => osc14, mode1=>mode);
U0_OSC16: ring_oscillator port map (en1 => rstn_osc(15), out1 => osc15, mode1=>mode);
U0_OSC17: ring_oscillator port map (en1 => rstn_osc(16), out1 => osc16, mode1=>mode);
U0_OSC18: ring_oscillator port map (en1 => rstn_osc(17), out1 => osc17, mode1=>mode);
U0_OSC19: ring_oscillator port map (en1 => rstn_osc(18), out1 => osc18, mode1=>mode);
U0_OSC20: ring_oscillator port map (en1 => rstn_osc(19), out1 => osc19, mode1=>mode);
U0_OSC21: ring_oscillator port map (en1 => rstn_osc(20), out1 => osc20, mode1=>mode);
U0_OSC22: ring_oscillator port map (en1 => rstn_osc(21), out1 => osc21, mode1=>mode);
U0_OSC23: ring_oscillator port map (en1 => rstn_osc(22), out1 => osc22, mode1=>mode);
U0_OSC24: ring_oscillator port map (en1 => rstn_osc(23), out1 => osc23, mode1=>mode);
U0_OSC25: ring_oscillator port map (en1 => rstn_osc(24), out1 => osc24, mode1=>mode);
U0_OSC26: ring_oscillator port map (en1 => rstn_osc(25), out1 => osc25, mode1=>mode);
U0_OSC27: ring_oscillator port map (en1 => rstn_osc(26), out1 => osc26, mode1=>mode);
U0_OSC28: ring_oscillator port map (en1 => rstn_osc(27), out1 => osc27, mode1=>mode);
U0_OSC29: ring_oscillator port map (en1 => rstn_osc(28), out1 => osc28, mode1=>mode);
U0_OSC30: ring_oscillator port map (en1 => rstn_osc(29), out1 => osc29, mode1=>mode);
U0_OSC31: ring_oscillator port map (en1 => rstn_osc(30), out1 => osc30, mode1=>mode);
U0_OSC32: ring_oscillator port map (en1 => rstn_osc(31), out1 => osc31, mode1=>mode);
U0_OSC33: ring_oscillator port map (en1 => rstn_osc(32), out1 => osc32, mode1=>mode);
U0_OSC34: ring_oscillator port map (en1 => rstn_osc(33), out1 => osc33, mode1=>mode);
U0_OSC35: ring_oscillator port map (en1 => rstn_osc(34), out1 => osc34, mode1=>mode);
U0_OSC36: ring_oscillator port map (en1 => rstn_osc(35), out1 => osc35, mode1=>mode);
U0_OSC37: ring_oscillator port map (en1 => rstn_osc(36), out1 => osc36, mode1=>mode);
U0_OSC38: ring_oscillator port map (en1 => rstn_osc(37), out1 => osc37, mode1=>mode);
U0_OSC39: ring_oscillator port map (en1 => rstn_osc(38), out1 => osc38, mode1=>mode);
U0_OSC40: ring_oscillator port map (en1 => rstn_osc(39), out1 => osc39, mode1=>mode);
U0_OSC41: ring_oscillator port map (en1 => rstn_osc(40), out1 => osc40, mode1=>mode);
U0_OSC42: ring_oscillator port map (en1 => rstn_osc(41), out1 => osc41, mode1=>mode);
U0_OSC43: ring_oscillator port map (en1 => rstn_osc(42), out1 => osc42, mode1=>mode);
U0_OSC44: ring_oscillator port map (en1 => rstn_osc(43), out1 => osc43, mode1=>mode);
U0_OSC45: ring_oscillator port map (en1 => rstn_osc(44), out1 => osc44, mode1=>mode);
U0_OSC46: ring_oscillator port map (en1 => rstn_osc(45), out1 => osc45, mode1=>mode);
U0_OSC47: ring_oscillator port map (en1 => rstn_osc(46), out1 => osc46, mode1=>mode);
U0_OSC48: ring_oscillator port map (en1 => rstn_osc(47), out1 => osc47, mode1=>mode);
U0_OSC49: ring_oscillator port map (en1 => rstn_osc(48), out1 => osc48, mode1=>mode);
U0_OSC50: ring_oscillator port map (en1 => rstn_osc(49), out1 => osc49, mode1=>mode);
U0_OSC51: ring_oscillator port map (en1 => rstn_osc(50), out1 => osc50, mode1=>mode);
U0_OSC52: ring_oscillator port map (en1 => rstn_osc(51), out1 => osc51, mode1=>mode);
U0_OSC53: ring_oscillator port map (en1 => rstn_osc(52), out1 => osc52, mode1=>mode);
U0_OSC54: ring_oscillator port map (en1 => rstn_osc(53), out1 => osc53, mode1=>mode);
U0_OSC55: ring_oscillator port map (en1 => rstn_osc(54), out1 => osc54, mode1=>mode);
U0_OSC56: ring_oscillator port map (en1 => rstn_osc(55), out1 => osc55, mode1=>mode);
U0_OSC57: ring_oscillator port map (en1 => rstn_osc(56), out1 => osc56, mode1=>mode);
U0_OSC58: ring_oscillator port map (en1 => rstn_osc(57), out1 => osc57, mode1=>mode);
U0_OSC59: ring_oscillator port map (en1 => rstn_osc(58), out1 => osc58, mode1=>mode);
U0_OSC60: ring_oscillator port map (en1 => rstn_osc(59), out1 => osc59, mode1=>mode);
U0_OSC61: ring_oscillator port map (en1 => rstn_osc(60), out1 => osc60, mode1=>mode);
U0_OSC62: ring_oscillator port map (en1 => rstn_osc(61), out1 => osc61, mode1=>mode);
U0_OSC63: ring_oscillator port map (en1 => rstn_osc(62), out1 => osc62, mode1=>mode);
U0_OSC64: ring_oscillator port map (en1 => rstn_osc(63), out1 => osc63, mode1=>mode);
U0_OSC65: ring_oscillator port map (en1 => rstn_osc(64), out1 => osc64, mode1=>mode);
U0_OSC66: ring_oscillator port map (en1 => rstn_osc(65), out1 => osc65, mode1=>mode);
U0_OSC67: ring_oscillator port map (en1 => rstn_osc(66), out1 => osc66, mode1=>mode);
U0_OSC68: ring_oscillator port map (en1 => rstn_osc(67), out1 => osc67, mode1=>mode);
U0_OSC69: ring_oscillator port map (en1 => rstn_osc(68), out1 => osc68, mode1=>mode);
U0_OSC70: ring_oscillator port map (en1 => rstn_osc(69), out1 => osc69, mode1=>mode);
U0_OSC71: ring_oscillator port map (en1 => rstn_osc(70), out1 => osc70, mode1=>mode);
U0_OSC72: ring_oscillator port map (en1 => rstn_osc(71), out1 => osc71, mode1=>mode);
U0_OSC73: ring_oscillator port map (en1 => rstn_osc(72), out1 => osc72, mode1=>mode);
U0_OSC74: ring_oscillator port map (en1 => rstn_osc(73), out1 => osc73, mode1=>mode);
U0_OSC75: ring_oscillator port map (en1 => rstn_osc(74), out1 => osc74, mode1=>mode);
U0_OSC76: ring_oscillator port map (en1 => rstn_osc(75), out1 => osc75, mode1=>mode);
U0_OSC77: ring_oscillator port map (en1 => rstn_osc(76), out1 => osc76, mode1=>mode);
U0_OSC78: ring_oscillator port map (en1 => rstn_osc(77), out1 => osc77, mode1=>mode);
U0_OSC79: ring_oscillator port map (en1 => rstn_osc(78), out1 => osc78, mode1=>mode);
U0_OSC80: ring_oscillator port map (en1 => rstn_osc(79), out1 => osc79, mode1=>mode);
U0_OSC81: ring_oscillator port map (en1 => rstn_osc(80), out1 => osc80, mode1=>mode);
U0_OSC82: ring_oscillator port map (en1 => rstn_osc(81), out1 => osc81, mode1=>mode);
U0_OSC83: ring_oscillator port map (en1 => rstn_osc(82), out1 => osc82, mode1=>mode);
U0_OSC84: ring_oscillator port map (en1 => rstn_osc(83), out1 => osc83, mode1=>mode);
U0_OSC85: ring_oscillator port map (en1 => rstn_osc(84), out1 => osc84, mode1=>mode);
U0_OSC86: ring_oscillator port map (en1 => rstn_osc(85), out1 => osc85, mode1=>mode);
U0_OSC87: ring_oscillator port map (en1 => rstn_osc(86), out1 => osc86, mode1=>mode);
U0_OSC88: ring_oscillator port map (en1 => rstn_osc(87), out1 => osc87, mode1=>mode);
U0_OSC89: ring_oscillator port map (en1 => rstn_osc(88), out1 => osc88, mode1=>mode);
U0_OSC90: ring_oscillator port map (en1 => rstn_osc(89), out1 => osc89, mode1=>mode);
U0_OSC91: ring_oscillator port map (en1 => rstn_osc(90), out1 => osc90, mode1=>mode);
U0_OSC92: ring_oscillator port map (en1 => rstn_osc(91), out1 => osc91, mode1=>mode);
U0_OSC93: ring_oscillator port map (en1 => rstn_osc(92), out1 => osc92, mode1=>mode);
U0_OSC94: ring_oscillator port map (en1 => rstn_osc(93), out1 => osc93, mode1=>mode);
U0_OSC95: ring_oscillator port map (en1 => rstn_osc(94), out1 => osc94, mode1=>mode);
U0_OSC96: ring_oscillator port map (en1 => rstn_osc(95), out1 => osc95, mode1=>mode);
U0_OSC97: ring_oscillator port map (en1 => rstn_osc(96), out1 => osc96, mode1=>mode);
U0_OSC98: ring_oscillator port map (en1 => rstn_osc(97), out1 => osc97, mode1=>mode);
U0_OSC99: ring_oscillator port map (en1 => rstn_osc(98), out1 => osc98, mode1=>mode);
U0_OSC100: ring_oscillator port map (en1 => rstn_osc(99), out1 => osc99, mode1=>mode);
U0_OSC101: ring_oscillator port map (en1 => rstn_osc(100), out1 => osc100, mode1=>mode);
U0_OSC102: ring_oscillator port map (en1 => rstn_osc(101), out1 => osc101, mode1=>mode);
U0_OSC103: ring_oscillator port map (en1 => rstn_osc(102), out1 => osc102, mode1=>mode);
U0_OSC104: ring_oscillator port map (en1 => rstn_osc(103), out1 => osc103, mode1=>mode);
U0_OSC105: ring_oscillator port map (en1 => rstn_osc(104), out1 => osc104, mode1=>mode);
U0_OSC106: ring_oscillator port map (en1 => rstn_osc(105), out1 => osc105, mode1=>mode);
U0_OSC107: ring_oscillator port map (en1 => rstn_osc(106), out1 => osc106, mode1=>mode);
U0_OSC108: ring_oscillator port map (en1 => rstn_osc(107), out1 => osc107, mode1=>mode);
U0_OSC109: ring_oscillator port map (en1 => rstn_osc(108), out1 => osc108, mode1=>mode);
U0_OSC110: ring_oscillator port map (en1 => rstn_osc(109), out1 => osc109, mode1=>mode);
U0_OSC111: ring_oscillator port map (en1 => rstn_osc(110), out1 => osc110, mode1=>mode);
U0_OSC112: ring_oscillator port map (en1 => rstn_osc(111), out1 => osc111, mode1=>mode);
U0_OSC113: ring_oscillator port map (en1 => rstn_osc(112), out1 => osc112, mode1=>mode);
U0_OSC114: ring_oscillator port map (en1 => rstn_osc(113), out1 => osc113, mode1=>mode);
U0_OSC115: ring_oscillator port map (en1 => rstn_osc(114), out1 => osc114, mode1=>mode);
U0_OSC116: ring_oscillator port map (en1 => rstn_osc(115), out1 => osc115, mode1=>mode);
U0_OSC117: ring_oscillator port map (en1 => rstn_osc(116), out1 => osc116, mode1=>mode);
U0_OSC118: ring_oscillator port map (en1 => rstn_osc(117), out1 => osc117, mode1=>mode);
U0_OSC119: ring_oscillator port map (en1 => rstn_osc(118), out1 => osc118, mode1=>mode);
U0_OSC120: ring_oscillator port map (en1 => rstn_osc(119), out1 => osc119, mode1=>mode);
U0_OSC121: ring_oscillator port map (en1 => rstn_osc(120), out1 => osc120, mode1=>mode);
U0_OSC122: ring_oscillator port map (en1 => rstn_osc(121), out1 => osc121, mode1=>mode);
U0_OSC123: ring_oscillator port map (en1 => rstn_osc(122), out1 => osc122, mode1=>mode);
U0_OSC124: ring_oscillator port map (en1 => rstn_osc(123), out1 => osc123, mode1=>mode);
U0_OSC125: ring_oscillator port map (en1 => rstn_osc(124), out1 => osc124, mode1=>mode);
U0_OSC126: ring_oscillator port map (en1 => rstn_osc(125), out1 => osc125, mode1=>mode);
U0_OSC127: ring_oscillator port map (en1 => rstn_osc(126), out1 => osc126, mode1=>mode);
U0_OSC128: ring_oscillator port map (en1 => rstn_osc(127), out1 => osc127, mode1=>mode);
U0_OSC129: ring_oscillator port map (en1 => rstn_osc(128), out1 => osc128, mode1=>mode);
U0_OSC130: ring_oscillator port map (en1 => rstn_osc(129), out1 => osc129, mode1=>mode);
U0_OSC131: ring_oscillator port map (en1 => rstn_osc(130), out1 => osc130, mode1=>mode);
U0_OSC132: ring_oscillator port map (en1 => rstn_osc(131), out1 => osc131, mode1=>mode);
U0_OSC133: ring_oscillator port map (en1 => rstn_osc(132), out1 => osc132, mode1=>mode);
U0_OSC134: ring_oscillator port map (en1 => rstn_osc(133), out1 => osc133, mode1=>mode);
U0_OSC135: ring_oscillator port map (en1 => rstn_osc(134), out1 => osc134, mode1=>mode);
U0_OSC136: ring_oscillator port map (en1 => rstn_osc(135), out1 => osc135, mode1=>mode);
U0_OSC137: ring_oscillator port map (en1 => rstn_osc(136), out1 => osc136, mode1=>mode);
U0_OSC138: ring_oscillator port map (en1 => rstn_osc(137), out1 => osc137, mode1=>mode);
U0_OSC139: ring_oscillator port map (en1 => rstn_osc(138), out1 => osc138, mode1=>mode);
U0_OSC140: ring_oscillator port map (en1 => rstn_osc(139), out1 => osc139, mode1=>mode);
U0_OSC141: ring_oscillator port map (en1 => rstn_osc(140), out1 => osc140, mode1=>mode);
U0_OSC142: ring_oscillator port map (en1 => rstn_osc(141), out1 => osc141, mode1=>mode);
U0_OSC143: ring_oscillator port map (en1 => rstn_osc(142), out1 => osc142, mode1=>mode);
U0_OSC144: ring_oscillator port map (en1 => rstn_osc(143), out1 => osc143, mode1=>mode);
U0_OSC145: ring_oscillator port map (en1 => rstn_osc(144), out1 => osc144, mode1=>mode);
U0_OSC146: ring_oscillator port map (en1 => rstn_osc(145), out1 => osc145, mode1=>mode);
U0_OSC147: ring_oscillator port map (en1 => rstn_osc(146), out1 => osc146, mode1=>mode);
U0_OSC148: ring_oscillator port map (en1 => rstn_osc(147), out1 => osc147, mode1=>mode);
U0_OSC149: ring_oscillator port map (en1 => rstn_osc(148), out1 => osc148, mode1=>mode);
U0_OSC150: ring_oscillator port map (en1 => rstn_osc(149), out1 => osc149, mode1=>mode);
U0_OSC151: ring_oscillator port map (en1 => rstn_osc(150), out1 => osc150, mode1=>mode);
U0_OSC152: ring_oscillator port map (en1 => rstn_osc(151), out1 => osc151, mode1=>mode);
U0_OSC153: ring_oscillator port map (en1 => rstn_osc(152), out1 => osc152, mode1=>mode);
U0_OSC154: ring_oscillator port map (en1 => rstn_osc(153), out1 => osc153, mode1=>mode);
U0_OSC155: ring_oscillator port map (en1 => rstn_osc(154), out1 => osc154, mode1=>mode);
U0_OSC156: ring_oscillator port map (en1 => rstn_osc(155), out1 => osc155, mode1=>mode);
U0_OSC157: ring_oscillator port map (en1 => rstn_osc(156), out1 => osc156, mode1=>mode);
U0_OSC158: ring_oscillator port map (en1 => rstn_osc(157), out1 => osc157, mode1=>mode);
U0_OSC159: ring_oscillator port map (en1 => rstn_osc(158), out1 => osc158, mode1=>mode);
U0_OSC160: ring_oscillator port map (en1 => rstn_osc(159), out1 => osc159, mode1=>mode);
U0_OSC161: ring_oscillator port map (en1 => rstn_osc(160), out1 => osc160, mode1=>mode);
U0_OSC162: ring_oscillator port map (en1 => rstn_osc(161), out1 => osc161, mode1=>mode);
U0_OSC163: ring_oscillator port map (en1 => rstn_osc(162), out1 => osc162, mode1=>mode);
U0_OSC164: ring_oscillator port map (en1 => rstn_osc(163), out1 => osc163, mode1=>mode);
U0_OSC165: ring_oscillator port map (en1 => rstn_osc(164), out1 => osc164, mode1=>mode);
U0_OSC166: ring_oscillator port map (en1 => rstn_osc(165), out1 => osc165, mode1=>mode);
U0_OSC167: ring_oscillator port map (en1 => rstn_osc(166), out1 => osc166, mode1=>mode);
U0_OSC168: ring_oscillator port map (en1 => rstn_osc(167), out1 => osc167, mode1=>mode);
U0_OSC169: ring_oscillator port map (en1 => rstn_osc(168), out1 => osc168, mode1=>mode);
U0_OSC170: ring_oscillator port map (en1 => rstn_osc(169), out1 => osc169, mode1=>mode);
U0_OSC171: ring_oscillator port map (en1 => rstn_osc(170), out1 => osc170, mode1=>mode);
U0_OSC172: ring_oscillator port map (en1 => rstn_osc(171), out1 => osc171, mode1=>mode);
U0_OSC173: ring_oscillator port map (en1 => rstn_osc(172), out1 => osc172, mode1=>mode);
U0_OSC174: ring_oscillator port map (en1 => rstn_osc(173), out1 => osc173, mode1=>mode);
U0_OSC175: ring_oscillator port map (en1 => rstn_osc(174), out1 => osc174, mode1=>mode);
U0_OSC176: ring_oscillator port map (en1 => rstn_osc(175), out1 => osc175, mode1=>mode);
U0_OSC177: ring_oscillator port map (en1 => rstn_osc(176), out1 => osc176, mode1=>mode);
U0_OSC178: ring_oscillator port map (en1 => rstn_osc(177), out1 => osc177, mode1=>mode);
U0_OSC179: ring_oscillator port map (en1 => rstn_osc(178), out1 => osc178, mode1=>mode);
U0_OSC180: ring_oscillator port map (en1 => rstn_osc(179), out1 => osc179, mode1=>mode);
U0_OSC181: ring_oscillator port map (en1 => rstn_osc(180), out1 => osc180, mode1=>mode);
U0_OSC182: ring_oscillator port map (en1 => rstn_osc(181), out1 => osc181, mode1=>mode);
U0_OSC183: ring_oscillator port map (en1 => rstn_osc(182), out1 => osc182, mode1=>mode);
U0_OSC184: ring_oscillator port map (en1 => rstn_osc(183), out1 => osc183, mode1=>mode);
U0_OSC185: ring_oscillator port map (en1 => rstn_osc(184), out1 => osc184, mode1=>mode);
U0_OSC186: ring_oscillator port map (en1 => rstn_osc(185), out1 => osc185, mode1=>mode);
U0_OSC187: ring_oscillator port map (en1 => rstn_osc(186), out1 => osc186, mode1=>mode);
U0_OSC188: ring_oscillator port map (en1 => rstn_osc(187), out1 => osc187, mode1=>mode);
U0_OSC189: ring_oscillator port map (en1 => rstn_osc(188), out1 => osc188, mode1=>mode);
U0_OSC190: ring_oscillator port map (en1 => rstn_osc(189), out1 => osc189, mode1=>mode);
U0_OSC191: ring_oscillator port map (en1 => rstn_osc(190), out1 => osc190, mode1=>mode);
U0_OSC192: ring_oscillator port map (en1 => rstn_osc(191), out1 => osc191, mode1=>mode);
U0_OSC193: ring_oscillator port map (en1 => rstn_osc(192), out1 => osc192, mode1=>mode);
U0_OSC194: ring_oscillator port map (en1 => rstn_osc(193), out1 => osc193, mode1=>mode);
U0_OSC195: ring_oscillator port map (en1 => rstn_osc(194), out1 => osc194, mode1=>mode);
U0_OSC196: ring_oscillator port map (en1 => rstn_osc(195), out1 => osc195, mode1=>mode);
U0_OSC197: ring_oscillator port map (en1 => rstn_osc(196), out1 => osc196, mode1=>mode);
U0_OSC198: ring_oscillator port map (en1 => rstn_osc(197), out1 => osc197, mode1=>mode);
U0_OSC199: ring_oscillator port map (en1 => rstn_osc(198), out1 => osc198, mode1=>mode);
U0_OSC200: ring_oscillator port map (en1 => rstn_osc(199), out1 => osc199, mode1=>mode);
U0_OSC201: ring_oscillator port map (en1 => rstn_osc(200), out1 => osc200, mode1=>mode);
U0_OSC202: ring_oscillator port map (en1 => rstn_osc(201), out1 => osc201, mode1=>mode);
U0_OSC203: ring_oscillator port map (en1 => rstn_osc(202), out1 => osc202, mode1=>mode);
U0_OSC204: ring_oscillator port map (en1 => rstn_osc(203), out1 => osc203, mode1=>mode);
U0_OSC205: ring_oscillator port map (en1 => rstn_osc(204), out1 => osc204, mode1=>mode);
U0_OSC206: ring_oscillator port map (en1 => rstn_osc(205), out1 => osc205, mode1=>mode);
U0_OSC207: ring_oscillator port map (en1 => rstn_osc(206), out1 => osc206, mode1=>mode);
U0_OSC208: ring_oscillator port map (en1 => rstn_osc(207), out1 => osc207, mode1=>mode);
U0_OSC209: ring_oscillator port map (en1 => rstn_osc(208), out1 => osc208, mode1=>mode);
U0_OSC210: ring_oscillator port map (en1 => rstn_osc(209), out1 => osc209, mode1=>mode);
U0_OSC211: ring_oscillator port map (en1 => rstn_osc(210), out1 => osc210, mode1=>mode);
U0_OSC212: ring_oscillator port map (en1 => rstn_osc(211), out1 => osc211, mode1=>mode);
U0_OSC213: ring_oscillator port map (en1 => rstn_osc(212), out1 => osc212, mode1=>mode);
U0_OSC214: ring_oscillator port map (en1 => rstn_osc(213), out1 => osc213, mode1=>mode);
U0_OSC215: ring_oscillator port map (en1 => rstn_osc(214), out1 => osc214, mode1=>mode);
U0_OSC216: ring_oscillator port map (en1 => rstn_osc(215), out1 => osc215, mode1=>mode);
U0_OSC217: ring_oscillator port map (en1 => rstn_osc(216), out1 => osc216, mode1=>mode);
U0_OSC218: ring_oscillator port map (en1 => rstn_osc(217), out1 => osc217, mode1=>mode);
U0_OSC219: ring_oscillator port map (en1 => rstn_osc(218), out1 => osc218, mode1=>mode);
U0_OSC220: ring_oscillator port map (en1 => rstn_osc(219), out1 => osc219, mode1=>mode);
U0_OSC221: ring_oscillator port map (en1 => rstn_osc(220), out1 => osc220, mode1=>mode);
U0_OSC222: ring_oscillator port map (en1 => rstn_osc(221), out1 => osc221, mode1=>mode);
U0_OSC223: ring_oscillator port map (en1 => rstn_osc(222), out1 => osc222, mode1=>mode);
U0_OSC224: ring_oscillator port map (en1 => rstn_osc(223), out1 => osc223, mode1=>mode);
U0_OSC225: ring_oscillator port map (en1 => rstn_osc(224), out1 => osc224, mode1=>mode);
U0_OSC226: ring_oscillator port map (en1 => rstn_osc(225), out1 => osc225, mode1=>mode);
U0_OSC227: ring_oscillator port map (en1 => rstn_osc(226), out1 => osc226, mode1=>mode);
U0_OSC228: ring_oscillator port map (en1 => rstn_osc(227), out1 => osc227, mode1=>mode);
U0_OSC229: ring_oscillator port map (en1 => rstn_osc(228), out1 => osc228, mode1=>mode);
U0_OSC230: ring_oscillator port map (en1 => rstn_osc(229), out1 => osc229, mode1=>mode);
U0_OSC231: ring_oscillator port map (en1 => rstn_osc(230), out1 => osc230, mode1=>mode);
U0_OSC232: ring_oscillator port map (en1 => rstn_osc(231), out1 => osc231, mode1=>mode);
U0_OSC233: ring_oscillator port map (en1 => rstn_osc(232), out1 => osc232, mode1=>mode);
U0_OSC234: ring_oscillator port map (en1 => rstn_osc(233), out1 => osc233, mode1=>mode);
U0_OSC235: ring_oscillator port map (en1 => rstn_osc(234), out1 => osc234, mode1=>mode);
U0_OSC236: ring_oscillator port map (en1 => rstn_osc(235), out1 => osc235, mode1=>mode);
U0_OSC237: ring_oscillator port map (en1 => rstn_osc(236), out1 => osc236, mode1=>mode);
U0_OSC238: ring_oscillator port map (en1 => rstn_osc(237), out1 => osc237, mode1=>mode);
U0_OSC239: ring_oscillator port map (en1 => rstn_osc(238), out1 => osc238, mode1=>mode);
U0_OSC240: ring_oscillator port map (en1 => rstn_osc(239), out1 => osc239, mode1=>mode);
U0_OSC241: ring_oscillator port map (en1 => rstn_osc(240), out1 => osc240, mode1=>mode);
U0_OSC242: ring_oscillator port map (en1 => rstn_osc(241), out1 => osc241, mode1=>mode);
U0_OSC243: ring_oscillator port map (en1 => rstn_osc(242), out1 => osc242, mode1=>mode);
U0_OSC244: ring_oscillator port map (en1 => rstn_osc(243), out1 => osc243, mode1=>mode);
U0_OSC245: ring_oscillator port map (en1 => rstn_osc(244), out1 => osc244, mode1=>mode);
U0_OSC246: ring_oscillator port map (en1 => rstn_osc(245), out1 => osc245, mode1=>mode);
U0_OSC247: ring_oscillator port map (en1 => rstn_osc(246), out1 => osc246, mode1=>mode);
U0_OSC248: ring_oscillator port map (en1 => rstn_osc(247), out1 => osc247, mode1=>mode);
U0_OSC249: ring_oscillator port map (en1 => rstn_osc(248), out1 => osc248, mode1=>mode);
U0_OSC250: ring_oscillator port map (en1 => rstn_osc(249), out1 => osc249, mode1=>mode);
U0_OSC251: ring_oscillator port map (en1 => rstn_osc(250), out1 => osc250, mode1=>mode);
U0_OSC252: ring_oscillator port map (en1 => rstn_osc(251), out1 => osc251, mode1=>mode);
U0_OSC253: ring_oscillator port map (en1 => rstn_osc(252), out1 => osc252, mode1=>mode);
U0_OSC254: ring_oscillator port map (en1 => rstn_osc(253), out1 => osc253, mode1=>mode);
U0_OSC255: ring_oscillator port map (en1 => rstn_osc(254), out1 => osc254, mode1=>mode);
U0_OSC256: ring_oscillator port map (en1 => rstn_osc(255), out1 => osc255, mode1=>mode);


--Counter generatation
Counter1: counter port map(clk =>mux_out,rstn=>rstn_counter, ena=>ena_counter, count=>counter_out);

--Mux
MUX_all: mux128 port map(a0=>osc0,a1=>osc1,a2=>osc2,a3=>osc3,a4=>osc4,a5=>osc5,a6=>osc6,a7=>osc7,a8=>osc8,a9=>osc9,
a10=>osc10,a11=>osc11,a12=>osc12,a13=>osc13,a14=>osc14,a15=>osc15,a16=>osc16,a17=>osc17,a18=>osc18,a19=>osc19,a20=>osc20,
a21=>osc21,a22=>osc22,a23=>osc23,a24=>osc24,a25=>osc25,a26=>osc26,a27=>osc27,a28=>osc28,a29=>osc29,a30=>osc30,
a31=>osc31,a32=>osc32,a33=>osc33,a34=>osc34,a35=>osc35,a36=>osc36,a37=>osc37,a38=>osc38,a39=>osc39,a40=>osc40,
a41=>osc41,a42=>osc42,a43=>osc43,a44=>osc44,a45=>osc45,a46=>osc46,a47=>osc47,a48=>osc48,a49=>osc49,a50=>osc50,
a51=>osc51,a52=>osc52,a53=>osc53,a54=>osc54,a55=>osc55,a56=>osc56,a57=>osc57,a58=>osc58,a59=>osc59,a60=>osc60,
a61=>osc61,a62=>osc62,a63=>osc63,a64=>osc64,a65=>osc65,a66=>osc66,a67=>osc67,a68=>osc68,a69=>osc69,a70=>osc70,
a71=>osc71,a72=>osc72,a73=>osc73,a74=>osc74,a75=>osc75,a76=>osc76,a77=>osc77,a78=>osc78,a79=>osc79,a80=>osc80,
a81=>osc81,a82=>osc82,a83=>osc83,a84=>osc84,a85=>osc85,a86=>osc86,a87=>osc87,a88=>osc88,a89=>osc89,a90=>osc90,
a91=>osc91,a92=>osc92,a93=>osc93,a94=>osc94,a95=>osc95,a96=>osc96,a97=>osc97,a98=>osc98,a99=>osc99,
a100=>osc100,a101=>osc101,a102=>osc102,a103=>osc103,a104=>osc104,a105=>osc105,a106=>osc106,a107=>osc107,a108=>osc108,a109=>osc109,
a110=>osc110,a111=>osc111,a112=>osc112,a113=>osc113,a114=>osc114,a115=>osc115,a116=>osc116,a117=>osc117,a118=>osc118,a119=>osc119,a120=>osc120,
a121=>osc121,a122=>osc122,a123=>osc123,a124=>osc124,a125=>osc125,a126=>osc126,a127=>osc127,a128=>osc128,a129=>osc129,a130=>osc130,
a131=>osc131,a132=>osc132,a133=>osc133,a134=>osc134,a135=>osc135,a136=>osc136,a137=>osc137,a138=>osc138,a139=>osc139,a140=>osc140,
a141=>osc141,a142=>osc142,a143=>osc143,a144=>osc144,a145=>osc145,a146=>osc146,a147=>osc147,a148=>osc148,a149=>osc149,a150=>osc150,
a151=>osc151,a152=>osc152,a153=>osc153,a154=>osc154,a155=>osc155,a156=>osc156,a157=>osc157,a158=>osc158,a159=>osc159,a160=>osc160,
a161=>osc161,a162=>osc162,a163=>osc163,a164=>osc164,a165=>osc165,a166=>osc166,a167=>osc167,a168=>osc168,a169=>osc169,a170=>osc170,
a171=>osc171,a172=>osc172,a173=>osc173,a174=>osc174,a175=>osc175,a176=>osc176,a177=>osc177,a178=>osc178,a179=>osc179,a180=>osc180,
a181=>osc181,a182=>osc182,a183=>osc183,a184=>osc184,a185=>osc185,a186=>osc186,a187=>osc187,a188=>osc188,a189=>osc189,a190=>osc190,
a191=>osc191,a192=>osc192,a193=>osc193,a194=>osc194,a195=>osc195,a196=>osc196,a197=>osc197,a198=>osc198,a199=>osc199,
a200=>osc200,a201=>osc201,a202=>osc202,a203=>osc203,a204=>osc204,a205=>osc205,a206=>osc206,a207=>osc207,a208=>osc208,a209=>osc209,
a210=>osc210,a211=>osc211,a212=>osc212,a213=>osc213,a214=>osc214,a215=>osc215,a216=>osc216,a217=>osc217,a218=>osc218,a219=>osc219,a220=>osc220,
a221=>osc221,a222=>osc222,a223=>osc223,a224=>osc224,a225=>osc225,a226=>osc226,a227=>osc227,a228=>osc228,a229=>osc229,a230=>osc230,
a231=>osc231,a232=>osc232,a233=>osc233,a234=>osc234,a235=>osc235,a236=>osc236,a237=>osc237,a238=>osc238,a239=>osc239,a240=>osc240,
a241=>osc241,a242=>osc242,a243=>osc243,a244=>osc244,a245=>osc245,a246=>osc246,a247=>osc247,a248=>osc248,a249=>osc249,a250=>osc250,
a251=>osc251,a252=>osc252,a253=>osc253,a254=>osc254,a255=>osc255,sel=>sel,b=>mux_out);
--counter



--clk
main_clk1<=clk;
--dummyout(127)<=osc127;
--dummyout(126)<=osc126;
--dummyout(125)<=osc125;
--dummyout(124)<=osc124;
--dummyout(123)<=osc123;
--dummyout(122)<=osc122;
--dummyout(121)<=osc121;
--dummyout(120)<=osc120;
--dummyout(119)<=osc119;
--dummyout(118)<=osc118;
--dummyout(117)<=osc117;
--dummyout(116)<=osc116;
--dummyout(115)<=osc115;
--dummyout(114)<=osc114;
--dummyout(113)<=osc113;
--dummyout(112)<=osc112;
--dummyout(111)<=osc111;
--dummyout(110)<=osc110;
--dummyout(109)<=osc109;
--dummyout(108)<=osc108;
--dummyout(107)<=osc107;
--dummyout(106)<=osc106;
--dummyout(105)<=osc105;
--dummyout(104)<=osc104;
--dummyout(103)<=osc103;
--dummyout(102)<=osc102;
--dummyout(101)<=osc101;
--dummyout(100)<=osc100;
--dummyout(99)<=osc99;
--dummyout(98)<=osc98;
--dummyout(97)<=osc97;
--dummyout(96)<=osc96;
--dummyout(95)<=osc95;
--dummyout(94)<=osc94;
--dummyout(93)<=osc93;
--dummyout(92)<=osc92;
--dummyout(91)<=osc91;
--dummyout(90)<=osc90;
--dummyout(89)<=osc89;
--dummyout(88)<=osc88;
--dummyout(87)<=osc87;
--dummyout(86)<=osc86;
--dummyout(85)<=osc85;
--dummyout(84)<=osc84;
--dummyout(83)<=osc83;
--dummyout(82)<=osc82;
--dummyout(81)<=osc81;
--dummyout(80)<=osc80;
--dummyout(79)<=osc79;
--dummyout(78)<=osc78;
--dummyout(77)<=osc77;
--dummyout(76)<=osc76;
--dummyout(75)<=osc75;
--dummyout(74)<=osc74;
--dummyout(73)<=osc73;
--dummyout(72)<=osc72;
--dummyout(71)<=osc71;
--dummyout(70)<=osc70;
--dummyout(69)<=osc69;
--dummyout(68)<=osc68;
--dummyout(67)<=osc67;
--dummyout(66)<=osc66;
--dummyout(65)<=osc65;
--dummyout(64)<=osc64;
--dummyout(63)<=osc63;
--dummyout(62)<=osc62;
--dummyout(61)<=osc61;
--dummyout(60)<=osc60;
--dummyout(59)<=osc59;
--dummyout(58)<=osc58;
--dummyout(57)<=osc57;
--dummyout(56)<=osc56;
--dummyout(55)<=osc55;
--dummyout(54)<=osc54;
--dummyout(53)<=osc53;
--dummyout(52)<=osc52;
--dummyout(51)<=osc51;
--dummyout(50)<=osc50;
--dummyout(49)<=osc49;
--dummyout(48)<=osc48;
--dummyout(47)<=osc47;
--dummyout(46)<=osc46;
--dummyout(45)<=osc45;
--dummyout(44)<=osc44;
--dummyout(43)<=osc43;
--dummyout(42)<=osc42;
--dummyout(41)<=osc41;
--dummyout(40)<=osc40;
--dummyout(39)<=osc39;
--dummyout(38)<=osc38;
--dummyout(37)<=osc37;
--dummyout(36)<=osc36;
--dummyout(35)<=osc35;
--dummyout(34)<=osc34;
--dummyout(33)<=osc33;
--dummyout(32)<=osc32;
--dummyout(31)<=osc31;
--dummyout(30)<=osc30;
--dummyout(29)<=osc29;
--dummyout(28)<=osc28;
--dummyout(27)<=osc27;
--dummyout(26)<=osc26;
--dummyout(25)<=osc25;
--dummyout(24)<=osc24;
--dummyout(23)<=osc23;
--dummyout(22)<=osc22;
--dummyout(21)<=osc21;
--dummyout(20)<=osc20;
--dummyout(19)<=osc19;
--dummyout(18)<=osc18;
--dummyout(17)<=osc17;
--dummyout(16)<=osc16;
--dummyout(15)<=osc15;
--dummyout(14)<=osc14;
--dummyout(13)<=osc13;
--dummyout(12)<=osc12;
--dummyout(11)<=osc11;
--dummyout(10)<=osc10;
--dummyout(9)<=osc9;
--dummyout(8)<=osc8;
--dummyout(7)<=osc7;
--dummyout(6)<=osc6;
--dummyout(5)<=osc5;
--dummyout(4)<=osc4;
--dummyout(3)<=osc3;
--dummyout(2)<=osc2;
--dummyout(1)<=osc1;
--dummyout(0)<=osc0;













process(main_clk1)
begin

if rising_edge(main_clk1) then
case PUF_FSM is	
--receive challenge		 
when Receive_challenge =>
if count_rx<8 then	 
if RX_o_RX_DV='1' then		 
main_plaintext(63-count_rx*8)<=RX_o_RX_Byte(7);
main_plaintext(62-count_rx*8)<=RX_o_RX_Byte(6);
main_plaintext(61-count_rx*8)<=RX_o_RX_Byte(5);
main_plaintext(60-count_rx*8)<=RX_o_RX_Byte(4);
main_plaintext(59-count_rx*8)<=RX_o_RX_Byte(3);
main_plaintext(58-count_rx*8)<=RX_o_RX_Byte(2);
main_plaintext(57-count_rx*8)<=RX_o_RX_Byte(1);
main_plaintext(56-count_rx*8)<=RX_o_RX_Byte(0);
PUF_FSM<=Receive_challenge;
count_rx<=count_rx+1;
--mode 0
mode<='0';
wait7<=0;
wait8<=0;
else PUF_FSM<=Receive_challenge;
rstn_osc<="0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
rstn_counter<='0';
ena_counter<='0';
--mode 0
mode<='0';
wait7<=0;
wait8<=0;
end if;
else 
PUF_FSM<=PUF_pair_before;
--count_rx back to 0
count_rx<=0;
--64 bit in total, start from 0 to 63
bitvalue<=0;
--counter should start from 0
response1<=0;
response0<=0;
end if;

when PUF_pair_before =>
--mode 1
mode<='1';
if(wait7>5000) then
PUF_FSM<=PUF_pair;
else 
PUF_FSM<=PUF_pair_before;
wait7<=wait7+1;
end if;




when PUF_pair =>

--refresh tmp
response1_tmp<=0;
response0_tmp<=0;
--refresh
rstn_counter<='0';
ena_counter<='0';
Control1<=to_integer(unsigned(main_plaintext((bitvalue*8+7) downto bitvalue*8))); 
Control0<=255-to_integer(unsigned(main_plaintext((bitvalue*8+7) downto bitvalue*8))); 
PUF_FSM<=PUF_pair2;


when PUF_pair2 =>
--other coefficient should also be 0.
wait1<=0;
wait2<=0;
wait3<=0;
wait4<=0;
wait5<=0;
wait6<=0;
b<=0; 
rstn_counter<='0';
ena_counter<='0';
if(wait8>500) then
PUF_FSM<=PUF_pair1;
sel1<=std_logic_vector(to_unsigned(Control1, 8));
sel0<=std_logic_vector(to_unsigned(Control0, 8));
else 
PUF_FSM<=PUF_pair2;
wait8<=wait8+1;
end if;


when PUF_pair1 =>
--refresh tmp
response1_tmp<=0;
response0_tmp<=0;
--refresh
rstn_counter<='0';
ena_counter<='0';
if(wait6>500) then
PUF_FSM<=PUF_response1_start;
else 
PUF_FSM<=PUF_pair1;
wait6<=wait6+1;
end if;



when PUF_response1_start =>
rstn_osc(Control1)<='1';
sel<=sel1; 
if(wait1>50) then
PUF_FSM<=PUF_response1_counting;
else 
PUF_FSM<=PUF_response1_start;
wait1<=wait1+1;
end if;


when PUF_response1_counting =>
rstn_counter<='1';
ena_counter<='1';
if(b>50000)then --10000
PUF_FSM<=PUF_response1_calculation;
b<=0;
--stop counting
ena_counter<='0';
--turn off osc 1 
--rstn_osc(Control1)<='0';
rstn_osc<="0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
--turn off mux
sel<="11111111";
--response1_tmp<=to_integer(unsigned(counter_out));
else PUF_FSM<=PUF_response1_counting;
b<=b+1; 
end if;


when PUF_response1_calculation =>

response1<=response1+to_integer(unsigned(counter_out));
PUF_FSM<=PUF_response_mid;
--refresh counter
rstn_counter<='0';
ena_counter<='0';


when PUF_response_mid =>
rstn_counter<='0';
ena_counter<='0';
--refresh tmp
response1_tmp<=0;
response0_tmp<=0;
if(wait3>50) then
PUF_FSM<=PUF_response0_start;
else 
PUF_FSM<=PUF_response_mid;
wait3<=wait3+1;
end if;


when PUF_response0_start =>
--turn on osc 0
rstn_osc(Control0)<='1';
sel<=sel0; 
if(wait2>50) then
PUF_FSM<=PUF_response0_counting;
else 
PUF_FSM<=PUF_response0_start;
wait2<=wait2+1;
end if;


when PUF_response0_counting =>
rstn_counter<='1';
ena_counter<='1'; 
if(b>50000)then      --10000
PUF_FSM<=PUF_response0_calculation;
b<=0; 
--stop counting
ena_counter<='0';
--turn off osc 0 
rstn_osc<="0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
--turn off mux
sel<="11111111";

else PUF_FSM<=PUF_response0_counting;
b<=b+1; 
end if;


when PUF_response0_calculation =>


PUF_FSM<=PUF_response_mid1;
response0<=response0+to_integer(unsigned(counter_out));
--refresh counter
rstn_counter<='0';
ena_counter<='0';

when PUF_response_mid1 =>
rstn_counter<='0';
ena_counter<='0';
if(wait4>50) then
PUF_FSM<=PUF_response_judge;
else 
PUF_FSM<=PUF_response_mid1;
wait4<=wait4+1;
end if;



when PUF_response_judge =>

if(bitvalue<7) then
bitvalue<=bitvalue+1;
PUF_FSM<=PUF_pair;
else
PUF_FSM<=PUF_response_calculation;
end if;


when PUF_response_calculation =>
if(response1>response0) then
solution<='1';
main_ciphertext<=std_logic_vector(to_unsigned((response1), 64));
else solution<='0';
main_ciphertext<=std_logic_vector(to_unsigned((response0), 64));
end if;
PUF_FSM<=PUF_send_wait;


when PUF_send_wait =>
TX_i_TX_DV<='1';
if solution='1' then
TX_i_TX_Byte(0)<='1';
TX_i_TX_Byte(1)<='1';
TX_i_TX_Byte(2)<='1';
TX_i_TX_Byte(3)<='1';
TX_i_TX_Byte(4)<='1';
TX_i_TX_Byte(5)<='1';
TX_i_TX_Byte(6)<='1';
TX_i_TX_Byte(7)<='1';
PUF_FSM<=PUF_send_wait1;
else 
TX_i_TX_Byte(0)<='0';
TX_i_TX_Byte(1)<='0';
TX_i_TX_Byte(2)<='0';
TX_i_TX_Byte(3)<='0';
TX_i_TX_Byte(4)<='0';
TX_i_TX_Byte(5)<='0';
TX_i_TX_Byte(6)<='0';
TX_i_TX_Byte(7)<='0';
PUF_FSM<=PUF_send_wait1;
end if;

when PUF_send_wait1 =>
if TX_o_TX_Done='1' then
PUF_FSM<=Receive_challenge;
TX_i_TX_DV<='0';			 
else PUF_FSM<=PUF_send_wait1;
end if;



when others=> PUF_FSM<=Receive_challenge;

end case;
end if;

end process;

end architecture rtl;